unit hiShLabel;

interface

uses Kol,Share,Win;

type
 ThiShLabel = class(THIWin)
   private
     procedure SetAutoSize(Value:boolean);
     procedure SetAlignment(Value:TTextAlign);
     procedure SetVerticalAlign(Value:TVerticalAlign);
     procedure _OnClick( Sender: PObj );
     procedure _OnMouseEnter( Sender: PObj );
     procedure _OnMouseLeave( Sender: PObj );
   public
     _event_OnClick:THI_Event;
     _prop_FontColor:TColor;
     _prop_ColorHover:TColor;
     _prop_ColorShadow:TColor;
     _prop_ShadowDeep:integer;
     _prop_FontOrient:integer;
     _prop_FontSize:integer;
     _prop_Cursor:integer;
     _prop_Underline:boolean;
     _prop_Caption:string;
     _prop_Antialiased:boolean;
     _prop_IntAdjustFont:boolean;
     _data_Text:THI_Event;

     constructor Create(Parent:PControl);
     procedure _work_doText(var Data:TData; Index:word);
     procedure _work_doFontColor(var Data:TData; Index:word);
     procedure _work_doFontSize(var Data:TData; Index:word);
     procedure _work_doColorShadow(var Data:TData; Index:word);
     procedure _work_doColorHover(var Data:TData; Index:word);
     procedure _work_doAntialiased(var Data:TData; Index:word);
     procedure _work_doUnderline(var Data:TData; Index:word);
     procedure _work_doShadowDeep(var Data:TData; Index:word);
     procedure _work_doFontOrient(var Data:TData; Index:word);
     procedure _work_doIntAdjustFont(var Data:TData; Index:word);
     procedure _var_Caption(var Data:TData; Index:word);
     procedure Init; override;
     property _prop_Alignment:TTextAlign write SetAlignment;
     property _prop_VerticalAlign:TVerticalAlign write SetVerticalAlign;
     property _prop_AutoSize:boolean write SetAutoSize;
 end;

implementation

constructor ThiShLabel.Create;
begin
   inherited Create(Parent);
   Control := NewLabelEffect(Parent,'',0);
   Control.OnClick := _OnClick;
   Control.OnMouseEnter:=_OnMouseEnter;
   Control.OnMouseLeave:=_OnMouseLeave;
end;

procedure ThiShLabel.Init;
begin
   inherited;
   Control.Caption := _prop_Caption;
   Control.ShadowDeep:=_prop_ShadowDeep;
   Control.Color2:= _prop_ColorShadow;
   if _prop_Antialiased then Control.Font.FontQuality:= fqAntialiased
   else Control.Font.FontQuality:= fqDefault;
   if _prop_FontOrient >= 0 then Control.Font.FontOrientation:= _prop_FontOrient * 10;
   if _prop_IntAdjustFont then
      begin
         Control.Font.Color:= _prop_Font.Color;
         Control.Font.FontHeight:= 6 + _prop_Font.Size;
      end
   else
      begin
         Control.Font.Color:= _prop_FontColor;
         Control.Font.FontHeight:= 6 + _prop_FontSize;
      end;
end;

procedure ThiShLabel._OnClick;
begin
   _hi_OnEvent(_event_OnClick);
end;

procedure ThiShLabel._OnMouseEnter;
begin
   if _prop_ColorHover <> 0 then
      Control.Font.Color := _prop_ColorHover;
   if _prop_Cursor <> 0 then
      Control.Cursor := _prop_Cursor;
   if _prop_Underline then
      Control.Font.FontStyle := Control.Font.FontStyle + [fsUnderline];
end;

procedure ThiShLabel._OnMouseLeave;
begin
   if _prop_ColorHover <> 0 then
      if _prop_IntAdjustFont then Control.Font.Color:= _prop_Font.Color
      else Control.Font.Color:= _prop_FontColor;

   if _prop_Cursor <> 0 then
      Control.Cursor := crDefault;
   if _prop_Underline then
      Control.Font.FontStyle := Control.Font.FontStyle - [fsUnderline];
   if _prop_IntAdjustFont then Exit;
   Control.Font.FontHeight:= 6 + _prop_FontSize;
end;

procedure ThiShLabel._work_DoText;
begin
   Control.Caption := ReadString(Data,_data_Text,'');
end;

procedure ThiShLabel.SetAlignment;
begin
  Control.TextAlign := Value;
end;

procedure ThiShLabel.SetVerticalAlign;
begin
  Control.VerticalAlign := Value;
end;

procedure ThiShLabel.SetAutoSize;
begin
   Control.AutoSize( Value );
end;

procedure ThiShLabel._var_Caption;
begin
   Data.Data_type := data_str;
   Data.sdata := Control.Caption;
end;

procedure ThiShLabel._work_doShadowDeep;
begin
   _prop_ShadowDeep:= Tointeger(Data);
   Control.ShadowDeep:=_prop_ShadowDeep;
end;

procedure ThiShLabel._work_doColorShadow;
begin
   _prop_ColorShadow:= Tointeger(Data);
   Control.Color2:=_prop_ColorShadow;
end;

procedure ThiShLabel._work_doFontColor;
begin
   if _prop_IntAdjustFont then Exit;
   _prop_FontColor:= Tointeger(Data);
   Control.Font.Color:= _prop_FontColor;
end;

procedure ThiShLabel._work_doFontSize;
begin
   if _prop_IntAdjustFont then Exit;
   _prop_FontSize:= Tointeger(Data);
   Control.Font.FontHeight:= 6 + _prop_FontSize;
end;

procedure ThiShLabel._work_doColorHover;
begin
   _prop_ColorHover:= Tointeger(Data);
end;

procedure ThiShLabel._work_doUnderline;
begin
   _prop_Underline:= Readbool(Data);
end;

procedure ThiShLabel._work_doIntAdjustFont;
begin
   _prop_IntAdjustFont:= Readbool(Data);
   if _prop_IntAdjustFont then
      begin
         Control.Font.Color:= _prop_Font.Color;
         Control.Font.FontHeight:= 6 + _prop_Font.Size;
      end
   else
      begin
         Control.Font.Color:= _prop_FontColor;
         Control.Font.FontHeight:= 6 + _prop_FontSize;
      end;
end;

procedure ThiShLabel._work_doAntialiased;
begin
   _prop_Antialiased:= Readbool(Data);
   if _prop_Antialiased then Control.Font.FontQuality:= fqAntialiased
   else Control.Font.FontQuality:= fqDefault;
end;

procedure ThiShLabel._work_doFontOrient;
begin
   _prop_FontOrient:= Tointeger(Data);
   if _prop_FontOrient >= 0 then Control.Font.FontOrientation:= _prop_FontOrient * 10;
end;

end.